name: Actions
on:
  push:
    branches:
      - main
  pull_request:

jobs:
  lint:
    name: Lint Code (Ruff & Pylint)
    runs-on: docker
    container: www.coastalcommits.com/cswimr/actions:uv@sha256:211aaf7d9ac98087579ebf9fab87a9122f51b2697e3a3649ac9f4bd3b03b8e5d
    steps:
      - name: Checkout
        uses: actions/checkout@11bd71901bbe5b1630ceea73d27597364c9af683 # v4

      - name: Install python
        run: uv python install 3.11

      - name: Install dependencies
        run: uv sync

      - name: Analysing code with Ruff
        run: uv run ruff check $(git ls-files '*.py')
        continue-on-error: true

      - name: Analysing code with Pylint
        run: uv run pylint --rcfile=.forgejo/workflows/config/.pylintrc $(git ls-files '*.py')

  docs:
    name: Build Documentation (MkDocs)
    runs-on: docker
    container: www.coastalcommits.com/cswimr/actions:docs@sha256:e405cd6b9b1182a570ddee32ed8dd1b2f899edc625d006c8b4b2f18c100e724f
    steps:
      - name: Checkout
        uses: actions/checkout@11bd71901bbe5b1630ceea73d27597364c9af683 # v4
        with:
          fetch-depth: 0

      - name: Install python
        run: uv python install 3.11

      - name: Install dependencies
        run: uv sync --no-dev --extra=documentation

      - name: Set environment variables
        uses: actions/env@v2

      - name: Build documentation
        run: |
          export SITE_URL="https://$CI_ACTION_REF_NAME_SLUG.seacogs.coastalcommits.com"
          export EDIT_URI="src/branch/$CI_ACTION_REF_NAME/.docs"
          uv run mkdocs build -v

      - name: Deploy documentation
        run: |
          GREEN='\033[0;32m'
          YELLOW='\033[0;33m'
          BLUE='\033[0;34m'

          unset GITHUB_TOKEN
          unset GITLAB_TOKEN

          echo "${YELLOW}Deploying to ${BLUE}Meli ${YELLOW}on branch ${GREEN}$CI_ACTION_REF_NAME_SLUG${YELLOW}...\n"

          npx -p "@getmeli/cli" meli upload ./site \
            --url "https://pages.coastalcommits.com" \
            --site "${{ vars.MELI_SITE_ID }}" \
            --token "${{ secrets.MELI_TOKEN }}" \
            --release "$CI_ACTION_REF_NAME_SLUG/${{ env.GITHUB_SHA }}" \
            --branch "$CI_ACTION_REF_NAME_SLUG"

          echo "\n${YELLOW}Deployed to ${BLUE}Meli ${YELLOW}on branch ${GREEN}$CI_ACTION_REF_NAME_SLUG${YELLOW}!"
          echo "${GREEN}https://$CI_ACTION_REF_NAME_SLUG.seacogs.coastalcommits.com/"
        env:
          GITEA_TOKEN: ${{ secrets.COASTALCOMMITSTOKEN }}
